#-*-mode:makefile-gmake;indent-tabs-mode:t;tab-width:8;coding:utf-8-*-┐
#── vi: set noet ft=make ts=8 sw=8 fenc=utf-8 :vi ────────────────────┘

PKGS += THIRD_PARTY_DOUBLECONVERSION

THIRD_PARTY_DOUBLECONVERSION_ARTIFACTS += THIRD_PARTY_DOUBLECONVERSION_A

THIRD_PARTY_DOUBLECONVERSION =							\
	$(THIRD_PARTY_DOUBLECONVERSION_A_DEPS)					\
	$(THIRD_PARTY_DOUBLECONVERSION_A)

THIRD_PARTY_DOUBLECONVERSION_A =						\
	o/$(MODE)/third_party/double-conversion/libdouble-conversion.a

THIRD_PARTY_DOUBLECONVERSION_A_FILES := $(wildcard third_party/double-conversion/*)
THIRD_PARTY_DOUBLECONVERSION_A_SRCS_C = $(filter %.c,$(THIRD_PARTY_DOUBLECONVERSION_A_FILES))
THIRD_PARTY_DOUBLECONVERSION_A_SRCS_CC = $(filter %.cc,$(THIRD_PARTY_DOUBLECONVERSION_A_FILES))
THIRD_PARTY_DOUBLECONVERSION_A_HDRS = $(filter %.h,$(THIRD_PARTY_DOUBLECONVERSION_A_FILES))

THIRD_PARTY_DOUBLECONVERSION_A_SRCS =						\
	$(THIRD_PARTY_DOUBLECONVERSION_A_SRCS_C)				\
	$(THIRD_PARTY_DOUBLECONVERSION_A_SRCS_CC)

THIRD_PARTY_DOUBLECONVERSION_A_OBJS =						\
	$(THIRD_PARTY_DOUBLECONVERSION_A_SRCS_C:%.c=o/$(MODE)/%.o)		\
	$(THIRD_PARTY_DOUBLECONVERSION_A_SRCS_CC:%.cc=o/$(MODE)/%.o)

THIRD_PARTY_DOUBLECONVERSION_A_CHECKS =						\
	$(THIRD_PARTY_DOUBLECONVERSION_A).pkg					\
	$(THIRD_PARTY_DOUBLECONVERSION_A_HDRS:%=o/$(MODE)/%.okk)

THIRD_PARTY_DOUBLECONVERSION_A_DIRECTDEPS =					\
	LIBC_INTRIN								\
	LIBC_NEXGEN32E								\
	LIBC_RUNTIME								\
	LIBC_STR								\
	LIBC_TINYMATH

THIRD_PARTY_DOUBLECONVERSION_A_DEPS :=						\
	$(call uniq,$(foreach x,$(THIRD_PARTY_DOUBLECONVERSION_A_DIRECTDEPS),$($(x))))

$(THIRD_PARTY_DOUBLECONVERSION_A):						\
		third_party/double-conversion/					\
		$(THIRD_PARTY_DOUBLECONVERSION_A).pkg				\
		$(THIRD_PARTY_DOUBLECONVERSION_A_OBJS)

$(THIRD_PARTY_DOUBLECONVERSION_A).pkg:						\
		$(THIRD_PARTY_DOUBLECONVERSION_A_OBJS)				\
		$(foreach x,$(THIRD_PARTY_DOUBLECONVERSION_A_DIRECTDEPS),$($(x)_A).pkg)

$(THIRD_PARTY_DOUBLECONVERSION_A_OBJS): private					\
		CXXFLAGS +=							\
			-ffunction-sections					\
			-fdata-sections

THIRD_PARTY_DOUBLECONVERSION_LIBS = $(foreach x,$(THIRD_PARTY_DOUBLECONVERSION_ARTIFACTS),$($(x)))
THIRD_PARTY_DOUBLECONVERSION_SRCS = $(foreach x,$(THIRD_PARTY_DOUBLECONVERSION_ARTIFACTS),$($(x)_SRCS))
THIRD_PARTY_DOUBLECONVERSION_HDRS = $(foreach x,$(THIRD_PARTY_DOUBLECONVERSION_ARTIFACTS),$($(x)_HDRS))
THIRD_PARTY_DOUBLECONVERSION_CHECKS = $(foreach x,$(THIRD_PARTY_DOUBLECONVERSION_ARTIFACTS),$($(x)_CHECKS))
THIRD_PARTY_DOUBLECONVERSION_OBJS = $(foreach x,$(THIRD_PARTY_DOUBLECONVERSION_ARTIFACTS),$($(x)_OBJS))
$(THIRD_PARTY_DOUBLECONVERSION_A_OBJS): third_party/double-conversion/BUILD.mk

.PHONY: o/$(MODE)/third_party/double-conversion
o/$(MODE)/third_party/double-conversion:					\
		o/$(MODE)/third_party/double-conversion/test			\
		$(THIRD_PARTY_DOUBLECONVERSION_CHECKS)
